/*
**	main.c
**
*/
#include "mpeg.h"
#include "disp.h"
//----------------------------------//
//selectable defines can be changed
#define SX 1280
#define SY 640
//select one by trade off, speed and quality. nothing is every pixel.
//#define quarter
//#define half

// set color by rgb table or calculate adequate yuv
#define SET_COLOR
// if you don't define, must use_yuv

// ball expanding and shrink
#define Expand

// episoid circle trace
//#define Circle

// Using yuv separate format or direct writing to rgb Ximage
//#define use_yuv
//
//-----------------------------------//
#ifdef use_yuv
struct sif { unsigned char y[SY][SX]; unsigned char c[2][SY/2][SX/2]; };
typedef struct	sif SIF;
SIF image;
#else
Uc *image=0;
#endif

int cmp,ddt,x2=1,vhs,bgc,wid,step,pause,sync=1;
double cur, startt, spent;
char name[99];

struct poi{ float x; float y; float z; };
typedef struct poi Pt;
Pt point(x,y,z) { Pt p; p.x= x; p.y= y; p.z= z; return p; }
float ip(p,q) Pt p,q; { float r; r= p.x*q.x+ p.y*q.y + p.z*q.z; return r; }
Pt padd(a,b) Pt a,b; { a.x+=b.x; a.y+=b.y; a.z+=b.z; return a; }
Pt psub(a,b) Pt a,b; { a.x-=b.x; a.y-=b.y; a.z-=b.z; return a; }
Pt smp(k,p) float k; Pt p; { p.x*= k; p.y*= k; p.z*= k; return p; }
Pt norm(p)  Pt p; { return smp((float)sqrt(1./(p.x*p.x +p.y*p.y +p.z*p.z)),p); }

float cos1= 0.5;
float sin1= 1.7320508/2.;
float cos2= 0.9659;
float sin2= 0.2588;

Pt rotate(p) Pt p;
{ 
	float t;
	t=   p.x*cos1 -p.z*sin1;
	p.z= p.x*sin1 +p.z*cos1;
	p.x= t;
	t=   p.y*cos2 -p.z*sin2;
	p.z= p.y*sin2 +p.z*cos2;
	p.y= t;
	return p;
}

float distant(a,v) Pt a,v;
{
	float t1,t2,t3,r;

	t1= a.x*v.y-a.y*v.x;
	t2= a.y*v.z-a.z*v.y;
	t3= a.z*v.x-a.x*v.z;
	r= t1*t1+t2*t2+t3*t3;
	return r;
}

int rgb[16]= {
0x001040, 0x001030, 0xC0C050, 0xE0D050,
0x005010, 0x005010, 0xC0C050, 0xE0D050,//doubling of the upper line
0x3030FF, 0x5050D0, 0xB080B0, 0xC09090,
0xF0F0F0, 0xF0F0E0, 0xB080B0, 0xC09090, //doubling of the upper line
};
int rgbt[16];
int yuv[16][3];
/*
up,cross2,cross, ref 
0   0   0	0: outside bottom dark blue =  #001040;
0   0   0	1: inside bottom dark blue =  #001030;
0   1	0	0: outside underfloor green= #003010;
0   1	0	1: inside underfloor green= #004010;
0    x	1	0: outside floor yellow= #C0C050;
0    x	1	1: inside floor yellow= #E0D050;

1   0   0	0: outside sky blue =  #3030FF;
1   0   0	1: inside sky blue =   #5050D0;
1   1	0	0: outside 2nd seiling white= #F0F0F0;
1   1	0	1: inside 2nd seiling white= #F0F080;
1    x	1	0: outside seiling orange= #B080B0;
1    x	1	1: inside seiling orange=  #C09090;
*/
unsigned int *uidd;
clr(i,j,p,v,ref)
Pt p,v;
	{
	float t;
	int	ix,iz;
	int	luma,cb,cr;
	int	up,cross,cross2=0;
	int	ind;
	//static int c;

	up= (v.y>0);
	t= (-SY/2+SY*up-p.y)/v.y;
	ix= v.x*t+ p.x;
	iz= v.z*t+ p.z;
	ix= ix>>(8+up);
	iz= iz>>8;
	cross= ((ix&1)==(iz&1));
	if(cross==0){
		t= (-SY*2+(SY*4)*up-p.y)/v.y;
		ix= v.x*t+ p.x;
		iz= v.z*t+ p.z;
		ix= ix>>(8+up);
		iz= iz>>8;
		cross2= ((ix&1)==(iz&1));
		}
#ifdef SET_COLOR
	ind= up*8+cross2*4+cross*2+ref;
#ifdef use_yuv
	image.y[j][i]= yuv[ind][0];
	if((i&1)==0&&(j&1)==0){
		image.c[0][j/2][i/2]= yuv[ind][1];
		image.c[1][j/2][i/2]= yuv[ind][2];
		}
#else
#ifdef quarter
		return rgbt[ind];
#else
#ifdef half
		return rgbt[ind];
#else
		*uidd++ =rgbt[ind];
#endif
#endif
#endif
#else
	luma= 60+cross2*80+cross*180;
	image.y[j][i]= luma;
	if((i&1)==0&&(j&1)==0){
		cb= 100+cross2*20+up*40;
		cr= 80+cross*25+ref*50;
		image.c[0][j/2][i/2]= cb;
		image.c[1][j/2][i/2]= cr;
		}
#endif
	}


lay(t0)
	{
	int	i,j;
	Pt eye,a,b;
	float c1,r0,r2;
	float t= t0;//+0.5*(j&1);
	int c;

#ifdef Expand
	while(t0>200)t0-= 200;
	r0= abs(t0-100)+10; 
#else
	r0= 100;
#endif
	r2= r0*r0;

#ifdef Circle
	a= point((int)(-1000*sin(t*0.01))+750,-50,-(int)(200*cos(t*0.01))); 
	eye= smp(0.5, a);
#else
	//t= t+t*t/4;
	t= (t+t*t/4)/2;
	a= point(-500-(int)t,-100,(int)t); 
	eye= padd(a,smp(r2/2000.,point(270,50,-200)));
#endif
	b= psub(a,eye);
	c1= ip(b,b)-r2;

	uidd= (unsigned int*)dd;

#ifdef quarter
	for(j=3;j<SY;j+=2){
	for(c=i=1;i<SX;){
#else
#ifdef half
	for(j=0;j<SY;j++){
	for(c=i=1;i<SX;){
#else
	for(j=0;j<SY;j++){
	for(i=0;i<SX;i++){
#endif
#endif
		int	ref=0;
		int t, d;
		Pt p0= eye;
		Pt v= norm(rotate(point(i-SX/2, SY/2-j, SX)));
		if(distant(b,v)< r2) {
			float b1,k;
			Pt p1;
			b1= ip(b,v);
			p1= padd( eye, smp(b1-sqrt(b1*b1-c1), v) );
			k= -2.*ip(v,psub(p1,a))/r2;
			v= norm( padd( v, smp( k, psub(p1,a) ) ) );
			p0= p1;
			ref= 1;
			}
#ifdef quarter
		uidd[SX*j+i]= t= clr(i,j,p0,v,ref);
		if((i&1)==0&&(j&1)==0) { i+=3; j++; }
		else if((i&1)==0) { i++; goto lab1; }
		else if((j&1)==0) { j++; goto lab2; }
		else {
			d= t;
			if(c==t) uidd[SX*j+i-1]= t;	// left
			else { i--; continue; }
		lab1:
			if(uidd[SX*(j-2)+i]==d) uidd[SX*(j-1)+i]= d; // up
			else { j--; continue; }
		lab2:
			if(uidd[SX*(j-2)+i-2]==d) uidd[SX*(j-1)+i-1]= d; //  up left 
			else if(uidd[SX*(j-2)+i]==c) uidd[SX*(j-1)+i-1]= c; // up left
			else { i--; j--; continue; }
			c= d;
			i+=2;
		}
#else
#ifdef half
		uidd[SX*j+i]= t= clr(i,j,p0,v,ref);
		if((i&1)==0) i+=3;
		else if(c==t){ uidd[SX*j+i-1]= t; i+=2; }
			else { c= t; i--; }
#else
		clr(i,j,p0,v,ref);
#endif
#endif
		}}
	}

set_color(){
	int i;
#ifdef use_yuv
	for(i=0;i<16;i++){
		float r,g,b,y,cb,cr;
		r= (rgb[i]>>16)&255;
		g= (rgb[i]>>8)&255;
		b= (rgb[i])&255;
		r/= 255.;
		g/= 255.;
		b/= 255.;
		y= 0.299*r+0.587*g+0.114*b;
		cb= 0.564*(b-y);
		cr= 0.713*(r-y);
		yuv[i][0]= (int)(y*219+16);
		yuv[i][1]= (int)(cb*224+128);
		yuv[i][2]= (int)(cr*224+128);
	}
#else
extern Visual *vis;
	int rm,gm,bm;
	int rs,gs,bs;
	rm= vis->red_mask;
	gm= vis->green_mask;
	bm= vis->blue_mask;
	for(i=0;i<32;i++) if((rm <<i)&0x80000000)break; rs= i;
	for(i=0;i<32;i++) if((gm <<i)&0x80000000)break; gs= i;
	for(i=0;i<32;i++) if((bm <<i)&0x80000000)break; bs= i;
	for(i=0;i<16;i++){
		Ui r,g,b;
		r= ((rgb[i]>>16)&255)<<24;
		g= ((rgb[i]>>8)&255)<<24;
		b= ((rgb[i])&255)<<24;
                rgbt[i]= ((r>>rs)&rm)|((g>>gs)&gm)|((b>>bs)&bm);
	}
#endif
}

main(argc, argv) int argc; char	**argv; {
	int i;
	if(argc!=1){ fprintf(stderr,"Usage: %s\n",argv[0]); exit(1); }
	iwt(argv[0],&image,SX,SY);
	set_color();
	for(i= 0;i<=1000;i++){
		lay(i);
		sprintf(name,"%s%0d",argv[0],i);
		wt(name,&image,
#ifdef use_yuv
		1
#else
		0
#endif
		);
		if(pause){ i--; if(step) { i+=step; step= 0;} usleep(100000); }
		}
	}
